"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = run;
exports.initProject = initProject;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _task = _interopRequireDefault(require("./task"));

var _yargs = _interopRequireWildcard(require("yargs"));

var _execa = _interopRequireDefault(require("execa"));

var _chalk = _interopRequireDefault(require("chalk"));

var _inquirer = _interopRequireDefault(require("./tool/inquirer"));

function run() {
  return _run.apply(this, arguments);
}

function _run() {
  _run = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(Object.keys(_yargs.argv).length > 2)) {
              _context.next = 5;
              break;
            }

            console.log('\nUsage: serverless-express-starter <command>\n');
            console.log('where <command> is one of:\n');

            _yargs.default.showHelp();

            return _context.abrupt("return");

          case 5:
            if (isRequiredToolHasInstalled()) {
              _context.next = 7;
              break;
            }

            return _context.abrupt("return");

          case 7:
            _context.next = 9;
            return initProject();

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _run.apply(this, arguments);
}

function initProject() {
  return _initProject.apply(this, arguments);
}

function _initProject() {
  _initProject = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2() {
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _inquirer.default.run();

          case 2:
            if (!(_inquirer.default.name.trim().length === 0)) {
              _context2.next = 5;
              break;
            }

            console.log(_chalk.default.red('Please enter the project name.'));
            return _context2.abrupt("return");

          case 5:
            _context2.next = 7;
            return _task.default.createFiles(_inquirer.default);

          case 7:
            _context2.next = 9;
            return _task.default.installPackages(_inquirer.default);

          case 9:
            _context2.next = 11;
            return _task.default.runExtraSettings(_inquirer.default);

          case 11:
            _task.default.showCompleteMessages();

          case 12:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _initProject.apply(this, arguments);
}

function isRequiredToolHasInstalled() {
  try {
    _execa.default.shellSync('which git');
  } catch (error) {
    console.log(_chalk.default.red('serverless-express-started need to install git.'));
    return false;
  }

  return true;
}