"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _chalk = _interopRequireDefault(require("chalk"));

var _fs = require("fs");

var _del = _interopRequireDefault(require("del"));

var _path = require("path");

var _execa = _interopRequireDefault(require("execa"));

var _inquirer = require("./tool/inquirer");

var _packageManager = _interopRequireDefault(require("./tool/packageManager"));

var _eslint = _interopRequireDefault(require("./tool/eslint"));

var Task =
/*#__PURE__*/
function () {
  function Task() {
    (0, _classCallCheck2.default)(this, Task);
  }

  (0, _createClass2.default)(Task, [{
    key: "createFiles",
    value: function () {
      var _createFiles = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(inquirerRobot) {
        var projectName, projectPath, pkgManagerPlatform, typeChecker, packageContext;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                projectName = inquirerRobot.name;
                projectPath = (0, _path.join)(process.cwd(), inquirerRobot.name);
                pkgManagerPlatform = inquirerRobot.pkgManager;
                typeChecker = inquirerRobot.typeChecker;
                _context.next = 7;
                return (0, _execa.default)('git', ['clone', 'https://github.com/ambisign-gavin/serverless-express-starter.git', projectName]);

              case 7:
                _context.next = 9;
                return (0, _del.default)(this._joinFilesPath(projectPath, ['src', 'bin', '.gitignore', '.eslintrc.js', '.flowconfig', '.babelrc', '.git', 'package-lock.json', 'flow-typed', 'test', '.npmignore', 'demo.gif', 'jest.config.js', 'LICENSE', 'README.md']));

              case 9:
                _execa.default.shellSync("cp -a ".concat(typeChecker.generateTemplatePath(), ". ./"), {
                  cwd: projectPath
                });

                _context.next = 12;
                return (0, _del.default)(this._joinFilesPath(projectPath, ['template']));

              case 12:
                packageContext = _packageManager.default.generatePackageJson(pkgManagerPlatform, projectName, inquirerRobot.description);
                packageContext['scripts']['build'] = typeChecker.getBuildScript();
                (0, _fs.writeFileSync)((0, _path.join)(projectPath, 'package.json'), JSON.stringify(packageContext, null, 2) + '\n');
                _context.next = 20;
                break;

              case 17:
                _context.prev = 17;
                _context.t0 = _context["catch"](0);
                console.log('An error occurred while creating files:', _context.t0);

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 17]]);
      }));

      function createFiles(_x) {
        return _createFiles.apply(this, arguments);
      }

      return createFiles;
    }()
  }, {
    key: "_joinFilesPath",
    value: function _joinFilesPath(projectPath, files) {
      return files.map(function (file) {
        return (0, _path.join)(projectPath, file);
      });
    }
  }, {
    key: "installPackages",
    value: function () {
      var _installPackages = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(inquirerRobot) {
        var dependenciesModule, devDependenciesModule, projectPath, pkgManagerPlatform, typeChecker;
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                dependenciesModule = ['express@^4.0.0', 'serverless-http@^1.0.0'];
                devDependenciesModule = ['@babel/cli@^7.0.0', '@babel/core@^7.0.0', '@babel/plugin-transform-modules-commonjs@^7.0.0', 'cli-confirm@^1.0.0', 'serverless-offline@^4.0.0'];
                projectPath = (0, _path.join)(process.cwd(), inquirerRobot.name);
                pkgManagerPlatform = inquirerRobot.pkgManager;
                typeChecker = inquirerRobot.typeChecker;

                if (typeChecker.getInstallPackages().length > 0) {
                  devDependenciesModule.push.apply(devDependenciesModule, (0, _toConsumableArray2.default)(typeChecker.getInstallPackages()));
                }

                if (inquirerRobot.isUsedEslint) {
                  devDependenciesModule.push.apply(devDependenciesModule, (0, _toConsumableArray2.default)(_eslint.default.getInstallPackages()));
                }

                _context2.next = 10;
                return _packageManager.default.install(pkgManagerPlatform, projectPath, dependenciesModule, false);

              case 10:
                _context2.next = 12;
                return _packageManager.default.install(pkgManagerPlatform, projectPath, devDependenciesModule, true);

              case 12:
                _context2.next = 17;
                break;

              case 14:
                _context2.prev = 14;
                _context2.t0 = _context2["catch"](0);
                console.log('An error occurred while installing packages:', _context2.t0);

              case 17:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[0, 14]]);
      }));

      function installPackages(_x2) {
        return _installPackages.apply(this, arguments);
      }

      return installPackages;
    }()
  }, {
    key: "runExtraSettings",
    value: function () {
      var _runExtraSettings = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(inquirerRobot) {
        var projectPath, typeChecker, config;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                projectPath = (0, _path.join)(process.cwd(), inquirerRobot.name);
                typeChecker = inquirerRobot.typeChecker;
                _context3.next = 5;
                return typeChecker.runExtraSettings(projectPath);

              case 5:
                if (!inquirerRobot.isUsedEslint) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 8;
                return _eslint.default.init(projectPath);

              case 8:
                config = _eslint.default.loadConfig(projectPath);
                config = typeChecker.injectSettingsToEslintConfig(config);

                _eslint.default.saveConfig(projectPath, config);

                _context3.next = 13;
                return _eslint.default.fixScripts(projectPath);

              case 13:
                _context3.next = 18;
                break;

              case 15:
                _context3.prev = 15;
                _context3.t0 = _context3["catch"](0);
                console.log('An error occurred while setting plugins:', _context3.t0);

              case 18:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, null, [[0, 15]]);
      }));

      function runExtraSettings(_x3) {
        return _runExtraSettings.apply(this, arguments);
      }

      return runExtraSettings;
    }()
  }, {
    key: "showCompleteMessages",
    value: function showCompleteMessages() {
      var messages = "\nIt's all done! You can start to develop your mighty project!\n\nYou can use:\n\n  npm/yarn run local               Run the local server.\n  npm/yarn run deploy:dev          Deploy the server of dev stage.\n  npm/yarn run deploy:production   Deploy the server of production stage.\n\nEnjoy it!\n        ";
      console.log(_chalk.default.green(messages));
    }
  }]);
  return Task;
}();

var task = new Task();
var _default = task;
exports.default = _default;