"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _execa = _interopRequireDefault(require("execa"));

var _fs = _interopRequireDefault(require("fs"));

var _path = require("path");

var _yaml = _interopRequireDefault(require("yaml"));

var Eslint =
/*#__PURE__*/
function () {
  function Eslint() {
    (0, _classCallCheck2.default)(this, Eslint);
  }

  (0, _createClass2.default)(Eslint, [{
    key: "getInstallPackages",
    value: function getInstallPackages() {
      return ['eslint@^5.0.0', 'babel-eslint@^10.0.0'];
    }
  }, {
    key: "init",
    value: function init(projectPath) {
      return (0, _execa.default)('node_modules/eslint/bin/eslint.js', ['--init'], {
        cwd: projectPath,
        stdio: 'inherit'
      });
    }
  }, {
    key: "loadConfig",
    value: function loadConfig(configPath) {
      var config = {};
      var jsConfig = (0, _path.join)(configPath, '.eslintrc.js');

      if (_fs.default.existsSync(jsConfig)) {
        config = require(jsConfig);
      }

      var jsonConfig = (0, _path.join)(configPath, '.eslintrc.json');

      if (_fs.default.existsSync(jsonConfig)) {
        config = require(jsonConfig);
      }

      var ymlConfig = (0, _path.join)(configPath, '.eslintrc.yml');

      if (_fs.default.existsSync(ymlConfig)) {
        var file = _fs.default.readFileSync(ymlConfig, 'utf8');

        config = _yaml.default.parse(file);
      }

      return config;
    }
  }, {
    key: "saveConfig",
    value: function saveConfig(configPath, config) {
      var jsConfig = (0, _path.join)(configPath, '.eslintrc.js');

      if (_fs.default.existsSync(jsConfig)) {
        var newEslintrc = 'module.exports = ' + JSON.stringify(config, null, 4) + '\n';

        _fs.default.writeFileSync(jsConfig, newEslintrc);
      }

      var jsonConfig = (0, _path.join)(configPath, '.eslintrc.json');

      if (_fs.default.existsSync(jsonConfig)) {
        var _newEslintrc = JSON.stringify(config, null, 4) + '\n';

        _fs.default.writeFileSync(jsonConfig, _newEslintrc);
      }

      var ymlConfig = (0, _path.join)(configPath, '.eslintrc.yml');

      if (_fs.default.existsSync(ymlConfig)) {
        var _newEslintrc2 = _yaml.default.stringify(config);

        _fs.default.writeFileSync(ymlConfig, _newEslintrc2);
      }
    }
  }, {
    key: "fixScripts",
    value: function fixScripts(projectPath) {
      return (0, _execa.default)('node_modules/eslint/bin/eslint.js', ['--fix', './src/*'], {
        cwd: projectPath,
        stdio: 'inherit'
      });
    }
  }]);
  return Eslint;
}();

var eslint = new Eslint();
var _default = eslint;
exports.default = _default;