"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.InquirerRobot = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inquirer = _interopRequireDefault(require("inquirer"));

var _fs = require("fs");

var _path = require("path");

var _interface = require("./typeChecker/interface");

var _noneChecker = require("./typeChecker/noneChecker");

var _factory = require("./typeChecker/factory");

function inquer(_x) {
  return _inquer.apply(this, arguments);
}

function _inquer() {
  _inquer = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(questions) {
    var answers;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _inquirer.default.prompt([questions]);

          case 2:
            answers = _context2.sent;
            return _context2.abrupt("return", answers[questions.name]);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _inquer.apply(this, arguments);
}

var InquirerRobot =
/*#__PURE__*/
function () {
  function InquirerRobot() {
    (0, _classCallCheck2.default)(this, InquirerRobot);
    (0, _defineProperty2.default)(this, "_name", '');
    (0, _defineProperty2.default)(this, "_description", '');
    (0, _defineProperty2.default)(this, "_pkgManager", 'npm');
    (0, _defineProperty2.default)(this, "_typeChecker", new _noneChecker.NoneTypeChecker());
    (0, _defineProperty2.default)(this, "_isUsedEslint", false);
  }

  (0, _createClass2.default)(InquirerRobot, [{
    key: "run",
    value: function () {
      var _run = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return inquer({
                  name: 'ProjectName',
                  message: 'How to name this mighty project?',
                  validate: function validate(name) {
                    if ((0, _fs.existsSync)((0, _path.join)(process.cwd(), name))) {
                      return 'This amazing name already exists.';
                    }

                    return true;
                  }
                });

              case 2:
                this._name = _context.sent;
                _context.next = 5;
                return inquer({
                  name: 'ProjectDescription',
                  message: 'How to describe this mighty project?'
                });

              case 5:
                this._description = _context.sent;
                _context.next = 8;
                return inquer({
                  type: 'list',
                  name: 'PackageManager',
                  message: 'Will this project use npm or yarn?',
                  choices: ['npm', 'yarn']
                });

              case 8:
                this._pkgManager = _context.sent;
                _context.t0 = _factory.typeCheckerFactory;
                _context.next = 12;
                return inquer({
                  type: 'list',
                  name: 'TypeChecker',
                  message: 'Do you want to use type checker?',
                  choices: ['none', 'flow', 'typescript']
                });

              case 12:
                _context.t1 = _context.sent;
                this._typeChecker = _context.t0.getTypeChecker.call(_context.t0, _context.t1);
                _context.next = 16;
                return inquer({
                  type: 'confirm',
                  name: 'UseEslint',
                  message: 'Do you want to use eslint?'
                });

              case 16:
                this._isUsedEslint = _context.sent;

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function run() {
        return _run.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: "name",
    get: function get() {
      return this._name;
    }
  }, {
    key: "description",
    get: function get() {
      return this._description;
    }
  }, {
    key: "pkgManager",
    get: function get() {
      return this._pkgManager;
    }
  }, {
    key: "typeChecker",
    get: function get() {
      return this._typeChecker;
    }
  }, {
    key: "isUsedEslint",
    get: function get() {
      return this._isUsedEslint;
    }
  }]);
  return InquirerRobot;
}();

exports.InquirerRobot = InquirerRobot;
var inquirerRobot = new InquirerRobot();
var _default = inquirerRobot;
exports.default = _default;