"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.typeCheckerFactory = void 0;

var _interface = require("./interface");

var _flow = require("./flow");

var _noneChecker = require("./noneChecker");

var _typeScript = require("./typeScript");

var typeCheckerFactory = {
  getTypeChecker: function getTypeChecker(typeCheckerPlatform) {
    switch (typeCheckerPlatform) {
      case 'flow':
        return new _flow.FlowTypeChecker();

      case 'typescript':
        return new _typeScript.TypeScriptTypeChecker();

      default:
        return new _noneChecker.NoneTypeChecker();
    }
  }
};
exports.typeCheckerFactory = typeCheckerFactory;