"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeScriptTypeChecker = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _interface = require("./interface");

var TypeScriptTypeChecker =
/*#__PURE__*/
function () {
  function TypeScriptTypeChecker() {
    (0, _classCallCheck2.default)(this, TypeScriptTypeChecker);
  }

  (0, _createClass2.default)(TypeScriptTypeChecker, [{
    key: "generateTemplatePath",
    value: function generateTemplatePath() {
      return 'template/typescript/';
    }
  }, {
    key: "getInstallPackages",
    value: function getInstallPackages() {
      //need to install aws-lambda to avoid this issue: https://github.com/dougmoscrop/serverless-http/issues/78
      return ['@types/aws-lambda@^8.0.0', '@types/express@^4.0.0', '@typescript-eslint/eslint-plugin@^1.0.0', '@typescript-eslint/parser@^1.0.0', 'typescript@^3.0.0'];
    }
  }, {
    key: "runExtraSettings",
    value: function runExtraSettings(projectPath) {
      return Promise.resolve();
    }
  }, {
    key: "injectSettingsToEslintConfig",
    value: function injectSettingsToEslintConfig(config) {
      var newConfig = (0, _objectSpread2.default)({}, config, {
        parser: '@typescript-eslint/parser',
        plugins: [].concat((0, _toConsumableArray2.default)(this._parseEslintConfigPropertyToArray(config.plugins)), ['@typescript-eslint']),
        extends: [].concat((0, _toConsumableArray2.default)(this._parseEslintConfigPropertyToArray(config.extends)), ['plugin:@typescript-eslint/recommended'])
      });
      return newConfig;
    }
  }, {
    key: "getBuildScript",
    value: function getBuildScript() {
      return 'tsc';
    }
  }, {
    key: "_parseEslintConfigPropertyToArray",
    value: function _parseEslintConfigPropertyToArray(property) {
      if (property == null) {
        return [];
      }

      if (Array.isArray(property)) {
        return property;
      }

      return [property];
    }
  }]);
  return TypeScriptTypeChecker;
}();

exports.TypeScriptTypeChecker = TypeScriptTypeChecker;